/*
**  dito.library 2.1
**  ----------------
**
**  (C) Copyright by Dirk Holtwick, 1996
**  All Rights Reserved.
*/

#ifndef CLIB_DITO_PROTOS_H
#define CLIB_DITO_PROTOS_H
#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif
#ifndef INTUITION_CLASSUSR_H
#include <intuition/classusr.h>
#endif
#ifdef __cplusplus
#define CLIBCPLUSON
#pragma -
#endif

#include <libraries/dito.h>

void DITO_InitPool (struct DITO_Pool *pool);
APTR DITO_AllocMem (struct DITO_Pool *pool, LONG size);
void DITO_FreePool (struct DITO_Pool *pool);
struct DITO_Database *DITO_CreateDatabase (void);
void DITO_InitDatabase (struct DITO_Database *data);
void DITO_DisposeDatabase (struct DITO_Database *data);
int DITO_GetFileInfo(struct DITO_FileInfo *fi, char *name);
int DITO_LoadDatabase (struct DITO_Database *data, char *name);
int DITO_SaveDatabase (struct DITO_Database *data, char *name, LONG tag);
void DITO_SortDatabase (struct DITO_Database *data, LONG method);
void DITO_InitEntryInfo (struct DITO_EntryInfo *vi);
struct DITO_Entry *DITO_InsertEntry (struct DITO_Database *data, struct DITO_EntryInfo *vi);
void DITO_RemoveEntry (struct DITO_Database *data, ULONG num);
char *DITO_GetStr (struct DITO_Entry *entry, LONG id);
LONG DITO_GetVal (struct DITO_Entry *entry, LONG id);
void DITO_SetVal (struct DITO_Database *data, struct DITO_Entry *entry, LONG id, LONG val);
void DITO_SetSortPattern (struct DITO_Database *data, char *pattern);
int DITO_StrICmp (struct DITO_Database *data, char *s1, char *s2);
struct DITO_Entry *DITO_SetAct(struct DITO_Database *data, LONG num);
struct DITO_Entry *DITO_SetActDelta(struct DITO_Database *data, LONG delta);
void DITO_PreparsePattern (struct DITO_Database *data, char *src, char *dest, LONG destlen);
BOOL DITO_PatternCmp (struct DITO_Database *data, char *pat, char *str, LONG mode);
void DITO_GetUserInfo (struct DITO_UserInfo *user);
void DITO_PlaySample (char *name);
void DITO_Hook (struct Hook *hook, void *func);
void DITO_OptimizeDatabase (struct DITO_Database *data);
struct DITO_Entry *DITO_TeachRandom(struct DITO_Database *data, struct DITO_Random *random);
struct DITO_Entry *DITO_TeachDummy(struct DITO_Database *data, struct DITO_Random *random, struct DITO_entry **skip);
BOOL DITO_TeachKnown(struct DITO_Database *data, BOOL known);
void DITO_TeachInit(struct DITO_Database *data);
struct DITO_Entry *DITO_GetPtr (struct DITO_Database *data, ULONG num);
ULONG DITO_GetNum(struct DITO_Database *data, struct DITO_Entry *entry);
struct DITO_Dict *DITO_OpenDict(char *name);
void DITO_CloseDict(struct DITO_Dict *dt);
void DITO_LoadDictData(struct DITO_Database *data, struct DITO_Dict *dt, char *pat, LONG mode);
void DITO_Speak(char *language, char *text);

#ifdef CLIBCPLUSON
#undef CLIBCPLUSON
#pragma +
#endif
#endif

